package net.ch2.pc8.imouto.person;

import java.util.Calendar;

import net.ch2.pc8.imouto.Mediator;
import net.ch2.pc8.imouto.person.thread.ImoutoWritingThread;

import org.eclipse.swt.graphics.Color;

public class Imouto extends Person {
    
    /** 表情 - 素 */
    public static final String FACE_SU = "0000";
    /** 表情 - 照れ */
    public static final String FACE_TERE = "0001";
    /** 表情 - 驚き */
    public static final String FACE_ODOROKI = "0002";
    /** 表情 - 不安 */
    public static final String FACE_FUAN = "0003";
    /** 表情 - 落ち込み */
    public static final String FACE_OCHIKOMI = "0004";
    /** 表情 - 微笑み */
    public static final String FACE_HOHOEMI = "0005";
    /** 表情 - 目閉じ */
    public static final String FACE_ME_TOZI = "0006";
    /** 表情 - 怒り */
    public static final String FACE_IKARI = "0007";
    /** 表情 - 冷笑 */
    public static final String FACE_REISYO = "0008";
    /** 表情 - 照れ怒り */
    public static final String FACE_TERE_IKARI = "0009";
//    /** 表情 - 刮目 */
//    public static final String FACE_KATSUMOKU = "11";
//    /** 表情 - 歌 */
//    public static final String FACE_UTA = "25";

    // TODO いもうとの性格づけ
//    /** テンションの高さ */
//    private double tension;
//    /** 体調 */
//    private double taicho;
//    /** 眠み */
//    private double nemumi;
//    /** 好感度 */
//    private double koukando;
//    /** 素直さ */
//    private double sunaosa;
//    /** 約束を守る割合 */
//    private double yakusokuMamoruPercentage;
    
    private ImoutoWritingThread imoutoWritingThread;
//    private ArrayList activeThreadList;
    
    public Imouto(Mediator mediator, String name, Color color) {
        super(mediator, name, color);
    }

    public ImoutoWritingThread getImoutoWritingThread() { return imoutoWritingThread; }
    
    public void talk( String faceID, String message, boolean isStart, boolean doLineFeed ) {
        talk( faceID, message, null, isStart, doLineFeed );
    }
    
    public void talk( String faceID, String message, String voiceFileName, boolean isStart, boolean doLineFeed ) {
        mediator.setImoutoFace( faceID );
        mediator.talk( this, message, voiceFileName, isStart, doLineFeed );
        
    }
    
    /**
     * いもうとがおにーちゃんの書き込みに気づいたときに呼び出されます。
     * @param onichanMessage おにーちゃんのメッセージ
     */
    public void kiduku( String onichanMessage ) {
        imoutoWritingThread = new ImoutoWritingThread(mediator, onichanMessage);
        imoutoWritingThread.start();        
    }

    public String toString() {
        return getName();
    }

//    public void startThread(ImoutoTalkThreadBase thread) {
//        thread.start();
//    }
//    
//    public void stopThread(ImoutoTalkThreadBase thread) {
//        thread.interrupt();
//        thread = null;
//    }

    
    /**
     * 起動時の挨拶
     *
     */
    public void greet() {
        Calendar now = Calendar.getInstance();
        int hour = now.get( Calendar.HOUR_OF_DAY );
        if( hour >= 5 && hour < 12 ) {
            talk( Imouto.FACE_HOHOEMI, "おはよ、おにーちゃん。", true, true );
        } else if( hour >= 12 && hour < 19 ) {
            talk( Imouto.FACE_SU, "やっほーなのだ！", "yahho-nanoda.mp3", true, true );
        } else {
            talk( Imouto.FACE_HOHOEMI, "おかえりなさい！おにーちゃん。", true, true );
        }
        
    }

}
