package net.ch2.pc8.imouto.person.thread;

import java.text.SimpleDateFormat;
import java.util.Date;

import net.ch2.pc8.imouto.Mediator;
import net.ch2.pc8.imouto.person.Imouto;

public class ImoutoWritingThread extends ImoutoTalkThreadBase {

    private String onichanMessage;
    
    public ImoutoWritingThread( Mediator mediator, String onichanMessage ) {
        super(mediator);
        this.onichanMessage = onichanMessage;
        setName( getClass().getName() );
    }
    
    public void run() {
        if( onichanMessage == null || onichanMessage.length() == 0 ) { throw new IllegalArgumentException(); }
        inputMessage();
        lastTalkTime = System.currentTimeMillis();
    }
    
//    private void readOnichanMessage() {
//        try {
//            Thread.sleep( onichanMessage.length()*10 );
//        } catch( InterruptedException ie ) {}        
//    }
    
    private void inputMessage() {
        if( onichanMessage.equals("やあ") ) {
            talk( Imouto.FACE_HOHOEMI, "こんにちは、おにーちゃん。" );            
        } else if( onichanMessage.equals("おい") ) {
            talk( Imouto.FACE_IKARI, "なによー。" );            
        } else if( onichanMessage.equals("ばいばい") ) {
            talk( Imouto.FACE_HOHOEMI, "ばいばーい！" );
            mediator.getDisplay().syncExec( new ExitThread() );
        } else if( onichanMessage.equals("今何時？") ) {
            SimpleDateFormat sdf = new SimpleDateFormat( "h時m分" );
            talk( Imouto.FACE_ME_TOZI, "えーと...", true, false );
            talk( Imouto.FACE_SU, sdf.format(new Date())+"だよ～。", false, true );
        } else {
            talk( Imouto.FACE_SU, "きづいたよー。", "onichan_question.mp3" );
        }
    }

    public String outline() {
        return "おにーちゃんの発言に返事をする部品です。";
    }


}
