package net.ch2.pc8.imouto.person.thread.user;

import java.util.Calendar;
import java.util.GregorianCalendar;

import net.ch2.pc8.imouto.Mediator;
import net.ch2.pc8.imouto.person.Imouto;
import net.ch2.pc8.imouto.person.thread.ImoutoTalkThreadBase;
import net.ch2.pc8.imouto.util.Debugger;

/**
 * サンプル実装 - O'Clock通知
 * @author ore
 *
 */
public class ImoutoOClockTalkThread extends ImoutoTalkThreadBase {
//    private long lastTalkTime;
//    private boolean openForOClockTalk;
    private boolean stop;
    private int talkHour;
    
    public ImoutoOClockTalkThread(Mediator mediator) {
        super(mediator);
        setName( "O'Clock通知" );
    }
    
    public void run() {
        lastTalkTime = System.currentTimeMillis();
//        openForOClockTalk = true;
        talkHour = -1;
        while( !stop ) {
            Calendar nowCalendar = GregorianCalendar.getInstance();
            long now = nowCalendar.getTimeInMillis();
            int h = nowCalendar.get( Calendar.HOUR_OF_DAY );
            int m = nowCalendar.get( Calendar.MINUTE );
            if( m == 0 && talkHour!=h ) {
                talkHour = h;
//                String appendMessage = "";
                switch( h ) {
                    // 寝てる
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                        break;
                    // 朝
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                    case 10:
                    case 11:
                    case 12:
//                        mediator.getDisplay().syncExec( openThread );
                        noWaitTalk( Imouto.FACE_HOHOEMI, h + "時になったよ、おにーちゃん。" );
//                        openForOClockTalk = true;
                        lastTalkTime = now;
                        break;
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                    case 17:
//                        mediator.getDisplay().syncExec( openThread );
                        noWaitTalk( Imouto.FACE_HOHOEMI, (h-12) + "時だよ、おにーちゃん。" );
//                        openForOClockTalk = true;
                        lastTalkTime = now;
                        break;
                    case 18:
                    case 19:
                    case 20:
                    case 21:
                    case 22:
                    case 23:
                    case 24:
//                        mediator.getDisplay().syncExec( openThread );
                        noWaitTalk( Imouto.FACE_HOHOEMI, "おにーちゃん" + (h-12) + "時だよー。" );
//                        openForOClockTalk = true;
                        lastTalkTime = now;
                        break;
                }
//            } else if( now - lastTalkTime > 20*1000 ) {
//                mediator.getDisplay().syncExec( disposeThread );
//                openForOClockTalk = false;
            }
            
            try {
                Thread.sleep( 1000 );
            } catch( InterruptedException ie ) {
                stop = true;
            }
            checkWindow();
        }
Debugger.debug( "スレッド" + getName() + "が終了します..." );        
    }
    
    public String outline() {
        return "おにーちゃんに時間、教えてあげる！";
    }
}
