package net.ch2.pc8.imouto.person.thread.user;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;

import net.ch2.pc8.imouto.Mediator;
import net.ch2.pc8.imouto.person.Imouto;
import net.ch2.pc8.imouto.person.thread.ImoutoTalkThreadBase;
import net.ch2.pc8.imouto.util.Constant;
import net.ch2.pc8.imouto.util.Debugger;



/**
 * サンプル実装 - ランダムトーク
 * @author ore
 *
 */
public class ImoutoRandomTalkThread extends ImoutoTalkThreadBase {
//    private long lastTalkTime;
//    private boolean openForRandomTalk;
    private long lastTalkTimeThis;
    
    private boolean stop;
    
    public ImoutoRandomTalkThread(Mediator mediator) {
        super(mediator);
        setPriority( Thread.MIN_PRIORITY );
        setName( "ランダムトーク" );
    }
    
    public void run() {
//        OpenThread openThread = new OpenThread();
//        DisposeThread disposeThread = new DisposeThread();
        lastTalkTime = System.currentTimeMillis();
        lastTalkTimeThis = lastTalkTime;
//        openForRandomTalk = true;
        while( !stop ) {
            long now = System.currentTimeMillis();
Debugger.debug( "差: "+(now-lastTalkTime) );
Debugger.debug( "lTT: "+lastTalkTime );
            if( now - lastTalkTimeThis > 70*1000 /*&& !mediator.isTalkShellOpen()*/ ) {
//                mediator.getDisplay().syncExec( openThread );
                noWaitTalk( Imouto.FACE_SU, getRandomTalkMessage());
                lastTalkTime = now;
                lastTalkTimeThis = now;
//                openForRandomTalk = true;
//            } else if( now - lastTalkTime > 20*1000 && openForRandomTalk ) {
//                mediator.getDisplay().syncExec( disposeThread );
//                openForRandomTalk = false;
            }
            try {
                sleep(1000);
            } catch( InterruptedException ie ) {
                stop = true;
            }
            checkWindow();
        }
Debugger.debug( "スレッド" + getName() + "が終了します..." );        
    }
    
    
    public String outline() {
        return "おにーちゃんとおしゃべりしたいなー。。";
    }
    
    private String getRandomTalkMessage() {
        ArrayList list = new ArrayList();
        try {
            BufferedReader br = new BufferedReader( new InputStreamReader( new FileInputStream(Constant.DIRECTORY_IMOUTO + mediator.getImoutoDirectoryName() + "/random" ), "UTF-8"));
            for( String line; (line=br.readLine()) != null; ) {
                if( line.charAt(0) == '#' ) continue;
                list.add(line);
            }
        } catch( FileNotFoundException fnfe ) {
            fnfe.printStackTrace();
        } catch( IOException ioe ) {
            ioe.printStackTrace();
        }
        Collections.shuffle(list);
        return ((String[])list.toArray( new String[0] ))[0];
    }
}
