package net.ch2.pc8.imouto.ui;

import java.io.File;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.HashMap;

import net.ch2.pc8.imouto.Mediator;
import net.ch2.pc8.imouto.person.thread.ImoutoTalkThreadBase;
import net.ch2.pc8.imouto.person.thread.user.Dummy;
import net.ch2.pc8.imouto.util.Constant;
import net.ch2.pc8.imouto.util.MyUtil;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;


public class PopupMenu implements SelectionListener {
    private Mediator mediator;
    private Menu menu;
    private MenuItem changeSizeItem, imoutoItem, threadItem, exitItem;
    private Menu imoutoMenu;
    private MenuItem[] imoutoMenuItems;
    private Menu threadMenu;
    private MenuItem[] threadMenuItems;
    // start()されるのを待っているImoutoTalkThreadBaseのリスト。start→stopの状態ではないようにする。
//    private ArrayList waitForStartThreadList;
    /** MenuItemとImoutoTalkThreadBaseのマップ */
    private HashMap/*<MenuItem, ImoutoTalkThreadBase>*/ map;
    
    public PopupMenu(Mediator mediator) {
        this.mediator = mediator;
        menu = new Menu(mediator.getShellOfDesktopShell(), SWT.POP_UP);
//      TODO 未実装のため        
//        changeSizeItem = new MenuItem(menu, SWT.PUSH);
//        changeSizeItem.setText("大きさを変える");
//        changeSizeItem.setImage( new Image(null, Constant.ICON_TITLE) );
//        changeSizeItem.addSelectionListener(this);
//changeSizeItem.setEnabled(false);
        imoutoItem = new MenuItem(menu, SWT.MENU);
        imoutoMenu = new Menu(imoutoItem);
        imoutoItem.setMenu(imoutoMenu);
        imoutoItem.setText("いもうと");
        imoutoItem.setImage( new Image(null, Constant.ICON_TITLE) );
        File[] imoutoDirectories = mediator.getImoutoDirectories();
        imoutoMenuItems = new MenuItem[imoutoDirectories.length];
        for( int i=0; i<imoutoDirectories.length; i++ ) {
            imoutoMenuItems[i] = new MenuItem( imoutoMenu, SWT.RADIO );
            imoutoMenuItems[i].setText(imoutoDirectories[i].getName());
            imoutoMenuItems[i].addSelectionListener(this);
        }
        threadItem = new MenuItem(menu, SWT.MENU);
        threadMenu = new Menu(threadItem);
        threadItem.setMenu(threadMenu);
        threadItem.setText("部品");
        threadItem.setImage( new Image(null, Constant.ICON_TITLE) );
        new Dummy();
        Class[] classes = MyUtil.listPackageContents( "net.ch2.pc8.imouto.person.thread.user" );
//for(int i=0; i<classes.length; i++) Debugger.debug(classes[i]);
        ArrayList threadMenuItemList = new ArrayList();
        ArrayList imoutoTalkThreadBaseList = new ArrayList();
//        waitForStartThreadList = new ArrayList(3);
        for( int i=0; i<classes.length; i++ ) {
            if( classes[i].getSuperclass().equals( ImoutoTalkThreadBase.class ) ) {
                Constructor constructor;
                ImoutoTalkThreadBase base = null;
                try {
                    constructor = classes[i].getConstructor( new Class[]{Mediator.class} );
                    base = (ImoutoTalkThreadBase)constructor.newInstance( new Object[]{mediator} );
                } catch (SecurityException e) {
                    e.printStackTrace();
                } catch (IllegalArgumentException e) {
                    e.printStackTrace();
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InstantiationException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                }

                threadMenuItemList.add( base.getName() );
                imoutoTalkThreadBaseList.add(base);
            }
        }
        String[] strings = (String[])threadMenuItemList.toArray(new String[0]);
        ImoutoTalkThreadBase[] baseClasses = (ImoutoTalkThreadBase[])imoutoTalkThreadBaseList.toArray(new ImoutoTalkThreadBase[0]);
        threadMenuItems = new MenuItem[strings.length];
        map = new HashMap();
        for( int i=0; i<threadMenuItems.length; i++ ) {
            threadMenuItems[i] = new MenuItem( threadMenu, SWT.CHECK );
            threadMenuItems[i].setText( strings[i] );
            threadMenuItems[i].addSelectionListener(this);
            map.put( threadMenuItems[i], baseClasses[i] );
        }
        exitItem = new MenuItem(menu, SWT.PUSH);
        exitItem.setText("おしまい");
        exitItem.setImage( new Image(null, Constant.ICON_EXIT) );
        exitItem.addSelectionListener(this);
    }
    
    
    public void selectNowImoutoMenuItem(String imoutoDirectoryName) {
        for(int i=0; i<imoutoMenuItems.length; i++) {
            if( imoutoMenuItems[i].getText().equals(imoutoDirectoryName) ) {
                imoutoMenuItems[i].setSelection(true);
                break;
            }
        }
    }
    
    public void setVisible(boolean visible) {
        menu.setVisible(visible);
    }
    
    public void widgetSelected(SelectionEvent se) {
        MenuItem selectedItem = (MenuItem)se.getSource();
//Debugger.debug(selectedItem);        
        if( selectedItem == changeSizeItem ) {
            mediator.changeDesktopSize();
        } else if( selectedItem == exitItem ) {
            mediator.exit();
        } else if( selectedItem.getParent() == imoutoMenu ) {
            mediator.changeImouto( ((MenuItem)selectedItem).getText() );
        } else if( selectedItem.getParent() == threadMenu ) {
            ImoutoTalkThreadBase base = (ImoutoTalkThreadBase)map.get(selectedItem);
            // チェックなし→チェックありに変化
            if( selectedItem.getSelection() ) {
                mediator.startThread(base);
            // チェックあり→チェックなしに変化
            } else {
                mediator.stopThread(base);
            }
        }
    }

    public void widgetDefaultSelected(SelectionEvent e) {
    }
}
