package net.ch2.pc8.imouto.ui;

import net.ch2.pc8.imouto.Mediator;
import net.ch2.pc8.imouto.util.Constant;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.widgets.TrayItem;

public class TaskTray {
    private Tray tray;
    private TrayItem trayItem;
    
    public TaskTray(final Mediator mediator) {
        tray = mediator.getDisplay().getSystemTray();
        trayItem = new TrayItem(tray, SWT.NONE);
        trayItem.setToolTipText( "偽いもうとデスクトップ" );
        trayItem.setImage( new Image(mediator.getDisplay(), Constant.ICON_TRAY) );
        // タスクアイコン右クリックでポップアップメニューを表示
        trayItem.addListener( SWT.MenuDetect, new Listener() {
            public void handleEvent(Event e) {
                mediator.displayPopupMenu();
            }
        });
        trayItem.addSelectionListener( new SelectionAdapter() {
            // タスクアイコンダブルクリックでTalkShellを表示
            public void widgetDefaultSelected(SelectionEvent se) {
                mediator.getShellOfDesktopShell().forceActive();
            }
        });
    }

    public void dispose() {
        trayItem.dispose();
        tray.dispose();
    }
}
