package net.ch2.pc8.imouto.util;

import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;


public class Debugger {
    private static final boolean isDebug = false;
    private static final boolean writeFile = false;
    static SimpleDateFormat sdf = new SimpleDateFormat( "yyyy/MM/dd HH:mm:ss:SSS" );
    static FileWriter fw;
    
    static {
        if( writeFile ) {
            try {
                fw = new FileWriter( Constant.FILE_LOG, true );
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
    
    private Debugger() {}
    public static void debug( Object message ) {
        if( isDebug ) {
            Date date = new Date();
            System.out.println( "[" + sdf.format( date ) + "] " + message );
            if( writeFile ) {
                try {
                    fw.write( "[" + sdf.format( date ) + "] " + message + "\n" );
                    fw.flush();
                } catch( IOException ioe ) {
                    ioe.printStackTrace();
                }
            }
        }
    }
    
    public static void debug( Object[] messages ) {
        if( isDebug ) {
            Date date = new Date();
            System.out.println( "[" + sdf.format( date ) + "]" );
            for( int i=0; i<messages.length; i++ ) {
                System.out.println( messages[i] );
            }
            if( writeFile ) {
                try {
                    fw.write( "[" + sdf.format( date ) + "]\n" );
                    for( int i=0; i<messages.length; i++ ) {
                        fw.write( messages[i] + "\n" );
                        fw.flush();
                    }
                } catch( IOException ioe ) {
                    ioe.printStackTrace();
                }
            }
        }
    }    
}
