package net.ch2.pc8.imouto.util;

import java.io.FileNotFoundException;
import java.util.TreeMap;

import net.ch2.pc8.imouto.person.Imouto;

import org.eclipse.swt.SWTException;
import org.eclipse.swt.graphics.ImageData;

public class ImageFactory {
    private static TreeMap imageMap = new TreeMap();
    
    private static ImageFactory instance = new ImageFactory();
    
    private ImageFactory() {}
    
    public static ImageFactory getInstance() {
        return instance;
    }
    
    public static ImageData getImageData(String filePath) {
        ImageData imageData = (ImageData)imageMap.get(filePath);
        if( imageData == null ) {
            try {
                imageData = new ImageData(filePath);
                imageMap.put( filePath, imageData );
            // TODO 暫定措置。画像がない場合は何か割り当てる。
            } catch( SWTException swte ) {
                if(swte.getCause() instanceof FileNotFoundException) {
                    filePath = filePath.replaceFirst( "[0-9]{4}", Imouto.FACE_SU );
                    imageData = (ImageData)imageMap.get(filePath);
                    if( imageData == null ) throw swte;
                }
            }
        }
        return imageData;
    }
}
