package net.ch2.pc8.imouto.util;
import java.util.Properties;

/**
 * @see http://sei.qee.jp/program/java/ohjava/backnum/05/0094.html
 */
public class MyProperties extends Properties {
    public MyProperties() {
        super();
    }

    /**
     * String型データの取得
     */
    public String get(String key, String defaultValue) {
        return getProperty(key, defaultValue);
    }

    /**
     * boolean型データの取得
     */
    public boolean getBoolean(String key, boolean defaultValue) {
        return Boolean.getBoolean(getProperty(key, Boolean.toString(defaultValue)));
    }

    /**
     * int型データの取得
     */
    public int getInt(String key, int defaultValue) {
        String value = getProperty(key, Integer.toString(defaultValue));
        try {
            return Integer.parseInt(value);
        } catch (NumberFormatException e) {
            return defaultValue;
        }
    }

    /**
     * String型データの設定
     */
    public void put(String key, String value) {
        setProperty(key, value);
    }

    /**
     * boolean型データの設定
     */
    public void putBoolean(String key, boolean value) {
        setProperty(key, Boolean.toString(value));
    }

    /**
     * int型データの設定
     */
    public void putInt(String key, int value) {
        setProperty(key, Integer.toString(value));
    }
}