package net.ch2.pc8.imouto.util;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.FloatControl;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;

import com.sun.java.forum.util.ListPackageContents;

public class MyUtil {
    public static Class[] listPackageContents(String packageName) {
        Package p = Package.getPackage(packageName);
        // Debugger.debug(p);
        ListPackageContents lpc = new ListPackageContents(p, false);
        return (Class[]) lpc.getPackageContents().toArray(new Class[0]);
    }

    public static void playMP3(String voiceFileName) {
        File soundFile = new File(voiceFileName);
        AudioInputStream audioInputStream = null;
        try {
            audioInputStream = AudioSystem.getAudioInputStream(soundFile);
            playAudioStream(audioInputStream);
        } catch( FileNotFoundException fnfe ) {
            // nop
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if( audioInputStream != null ) {
                try {
                    audioInputStream.close();
                } catch (IOException e) {
                }
            }
        }
    }

    public static void playAudioStream(AudioInputStream audioInputStream) {
        AudioFormat audioFormat = audioInputStream.getFormat();
        AudioInputStream newStream = null;
        if (audioFormat.getEncoding() != AudioFormat.Encoding.PCM_SIGNED) {
            // if ((audioFormat.getEncoding() != AudioFormat.Encoding.PCM) ||
            // (audioFormat.getEncoding() == AudioFormat.Encoding.ALAW) ||
            // (audioFormat.getEncoding() == AudioFormat.Encoding.MP3)) {
            AudioFormat newFormat = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, audioFormat.getSampleRate(), 16, audioFormat.getChannels(), audioFormat.getChannels() * 2, audioFormat
                    .getSampleRate(), false);
            newStream = AudioSystem.getAudioInputStream(newFormat, audioInputStream);
            audioFormat = newFormat;
            audioInputStream = newStream;
        }

        DataLine.Info info = new DataLine.Info(SourceDataLine.class, audioFormat);
        if (!AudioSystem.isLineSupported(info)) {
            return;
        }

        SourceDataLine dataLine = null;
        try {
            dataLine = (SourceDataLine) AudioSystem.getLine(info);
            dataLine.open(audioFormat);
            if (dataLine.isControlSupported(FloatControl.Type.MASTER_GAIN)) {
                FloatControl volume = (FloatControl) dataLine.getControl(FloatControl.Type.MASTER_GAIN);
                volume.setValue(100.0F);
            }

            dataLine.start();

            int bufferSize = (int) audioFormat.getSampleRate() * audioFormat.getFrameSize();
            byte[] buffer = new byte[bufferSize];

            try {
                int bytesRead = 0;
                while (bytesRead >= 0) {
                    bytesRead = audioInputStream.read(buffer, 0, buffer.length);
                    if (bytesRead >= 0) {
                        /*int framesWritten = */dataLine.write(buffer, 0, bytesRead);
                    }
                }
            } catch (IOException e) {
                e.printStackTrace();
            }

            dataLine.drain();
        } catch (LineUnavailableException e) {
            e.printStackTrace();
        } finally {
            if( dataLine != null ) {
                dataLine.close();
            }
            if( newStream != null ) {
                try {
                    newStream.close();
                } catch (IOException e) {
                }
            }
        }
    }
}
